package assignment04;

/*
 *   Assignment04.java:
 *		Example solutions
 *		Assignment04 Class: Static Methods
 * 				Loops
 *				Flow control
 *	  mei_
 */

// package mei;
 
public class Assignment04 {
    
    
    // The number received as an argument is tested for being
    //    even and the result is returned as either true or false
    public static boolean isEven(int number) {
       return number%2==0;
       
        // The above is all that is required.
        // However, the solution below is clearer.
        // Yet, please note the warning NetBeans gives for the if statement:
        //   " the if statement is redundant"
       /*
        if (number%2==0)   // even numbers are divisible by 2
            return true;
        else		// if there is a leftover
            return false;
        */
        
     }
    
    
    //  Finding out the area of common areacodes.
    //   If the code received as argument is one of the common area codes
    //   listed below, the area is returned as a String.
    //  If the code is not one the common area codes, an appropriate String
    //  is returned.
    public static String resolveAreaCode(int code) {
	    // NOTE: In the following switch() statement, since all options
            //   directly lead to a return stement, there is no need for 
            //   break statements! 
            //   In fact, break statements will not be accepted since there
            //   is no possibility of reaching those statements. th return 
            //   statements end the method.
        switch(code){
            case 212 : return "Istanbul_1";
            case 216 : return "Istanbul_2";
            case 312 : return "Ankara";
            case 232 : return "Izmir";
            case 322 : return "Adana";
            case 266 : return "Balikesir";
            case 224 : return "Bursa";
            case 462 : return "Trabzon";
            case 532 : return "Turkcell";
	    case 542 : return "Vodafone";
            case 505 : return "TurkTelekom";
            default: return "Unknown_code";
        }
    }
    
    // Display (print it out to screen) the first n numbers in the Fibonacci
    //  series.
    public static void fibonacciSeries(int n) {
	    if (n<=0) {    			// if n is 0 or negative 
		    return;      		// do nothing!
	    }
	    System.out.println(0); 		// Display '0', the first number
	    if (n==1) {				// if n is 1, we are done
		    return;   			// end the method
	    }
	    System.out.println(1); 		// Display '1', the second number
	    int f1=0, f2=1, ft=0;		// temporary variables for calculations
	    for(int i=2 ; i<n ; i++ ) {     // loop for values of n greater or equal to 3
		    ft = f1+f2;			//   calculate the next number 
		    f1 = f2;			//   advance markers for last two
		    f2 = ft;			//   numbers in series
		    System.out.println(ft);     //   display the next number       
	    }
	    // if n is 2 we will not enter the above loop
	    // the loop ends after displaying n numbers.	
	    
	    // ALTERNATIVE 1 : Less lines of code
	    //   May be shorter but much harder to understand and track
	    /*   
	    if (n<=0)	return;
	    System.out.println(0);
	    for(int i=1, f1=1, f2=0, ft=1 ; i<n ; i++, f1=f2, f2=ft, ft=f1+f2 )
		    System.out.println(ft);           
	    */
	    
	    
	    // ALTERNATIVE 2 : More balanced
	    //   Please try to write code that is balanced between 
	    //	 readability and compactness
	    /*    
	    if (n<=0)	return;
	    System.out.println(0);
	    for(int i=1, f1=1, f2=0, ft=0 ; i<n ; i++) {
		    ft = f1+f2;
		    f1 = f2;
		    f2 = ft;
		    System.out.println(ft); 
	    }
	    */
    }
    
    // Display the fibonacci sequence that ends with the first number 
    //     greater than or equal to max
    public static void fibonacciUntil(int max) {    
	    if (max<0)	return;		// nothing to do is max is negative
	    System.out.println(0);	// otherwise start with printing '0'
	    int f1=1, f2=0, ft=0; 	// set temp markers
	    while ( ft<max ) {		// loop until at least equal to max
		    ft = f1+f2;		
		    f1 = f2;		//   same as the loop body above	
		    f2 = ft;
		    System.out.println(ft); 
	    }
    }
    
    // Display the squares of the first n integers starting with 0 
    public static void squares(int n) {
        if (n<=0) return;		// if n is negative, nothing to do
        for(int i=0 ; i<n ; i++){
            System.out.println( i*i );
        }
    }
    
    // Display the squares of integers starting with 0 ending with the first 
    //   square that is greater than or equal to max.
    public static void squaresUntil(int max) {
	    if (max<0) return;		// do nothing if max is negative
	    int square = -1;
	    for (int i=0; square < max ; i++) {
		    square = i*i;
		    System.out.println(square);
	    }
	    
	    
	    // ALTERNATIVE : 
	    /* 
	    if (max<0) return;		// do nothing if max is negative
	    int i=-1;
	    do {
		    i++;
		    System.out.println(i*i);
	    } while ( (i*i)<max );
	    */
    }
		
    // display tha average of 1000 random integers between 50-150 
    public static void randomTest() {
        int total=0;
        for (int i=0; i<1000 ;i++)
            total = total + (int)(Math.random()*101+50);   // multiply by the range and add the starting point
        System.out.println(total/1000); 
    }
    
    // do not display only return the average of n integers between 50-150
    public static int randomTestInt(int n) {
        int total=0;
        for (int i=0; i<n ;i++)
            total = total + (int)(Math.random()*101+50);   // multiply by the range and add the starting point
        return total/n; 
    }
	
    // display integers down from n to 0
    public static void countdown(int n) {
       while ( n >= 0 )
            System.out.println(n--);
    }
}